<?php

	App::uses('VebraAppController', 'Vebra.Controller');
	App::uses('Branch', 'Vebra.Model');

	/*
	 * To change this license header, choose License Headers in Project Properties.
	 * To change this template file, choose Tools | Templates
	 * and open the template in the editor.
	 */

	/**
	 * Description of PropertiesController
	 *
	 * @author Luke
	 */
	class PropertiesController extends VebraAppController {

		public $paginate = array(
			'limit' => 10,
			'order' => 'Property.price ASC',
			'contain' => array(
				'Paragraph',
				'Image'
			)
		);

		public function beforeFilter() {
			parent::beforeFilter();
			$this->Auth->allow();
			return $this;
		}

		public function index() {
			// Ge tavailable property types
			$property_types = $this->Property->find('all', array(
				'fields' => array(
					'DISTINCT (Property.type) AS property_type',
				),
				'order' => array(
					'Property.type ASC'
				)
			));
			$this->set('property_types', $property_types);

			// Get all properties (including filters etc.)
			$properties = $this->paginate('Property', array('Property.solddate IS NULL'), array('price', 'lastchanged'));
			$this->set('properties', $properties);
		}

		public function view($id) {
			$params = array(
				'conditions' => array(
					'Property.id' => $id
				),
				'contain' => array(
					'Paragraph',
					'Image',
					'FloorplanImage',
					'EpcImage',
					'Branch',
				)
			);

			$property = $this->Property->find('first', $params);
			$this->set('property', $property);

			$branch_name = $property['Branch']['name'];
			App::uses('SiteSettingCategory', 'SiteSettings.Model');
			$site_setting_category = (new SiteSettingCategory())->find('first', array('conditions' => array('name' => $branch_name)));
			if (is_array($site_setting_category) && !empty($site_setting_category)) {
				$this->set('telephone', Configure::read('SiteSetting.' . strtolower($branch_name) . '_telephone'));
			}
		}

		protected function _adminFormFields() {
			return array(); // we don't want any of the property information to be user-editable because it'll just get overwritten by the API, anyway
		}

	}
